"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabNavigator = TabNavigator;
exports.DrawerNavigator = DrawerNavigator;
exports.StackNavigator = StackNavigator;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require("react-redux");

var _reactNavigation = require("react-navigation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TabNavigator(routes, routeConfigs) {
  return function (navigationStoreKey) {
    return createRouter(_reactNavigation.TabNavigator, routes, routeConfigs, navigationStoreKey);
  };
}

function DrawerNavigator(routes, routeConfigs) {
  return function (navigationStoreKey) {
    return createRouter(_reactNavigation.DrawerNavigator, routes, routeConfigs, navigationStoreKey);
  };
}

function StackNavigator(routes, routeConfigs) {
  return function (navigationStoreKey) {
    return createRouter(_reactNavigation.StackNavigator, routes, routeConfigs, navigationStoreKey);
  };
}

function createRouter(navigator, routes, routeConfigs, navigationStoreKey) {
  var Router = navigator(routes, routeConfigs);

  function Wrapper(props) {
    var dispatch = props.dispatch,
        routeState = props.routeState;

    return _react2.default.createElement(Router, {
      navigation: (0, _reactNavigation.addNavigationHelpers)({
        dispatch: dispatch,
        state: routeState
      })
    });
  }

  var mapDataToProps = function mapDataToProps(state) {
    return {
      routeState: state[navigationStoreKey]
    };
  };

  var Container = (0, _reactRedux.connect)(mapDataToProps)(Wrapper);

  var initScreen = Object.keys(routes)[0];
  Container.initScreen = initScreen;
  Container.router = Router;
  return Container;
}